"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Put = exports.Post = exports.Patch = exports.Get = exports.Delete = exports.Controller = exports.ClassErrorMiddleware = exports.ErrorMiddleware = exports.ClassMiddleware = exports.Middleware = exports.createServer = exports.printRoutes = exports.listRoutes = exports.listen = exports.load = exports.notfound = exports.err = exports.unauthorized = exports.ok = void 0;
const hypernight_1 = require("@hyperstackjs/hypernight");
const async_express_mw_1 = __importDefault(require("async-express-mw"));
const lodash_1 = __importDefault(require("lodash"));
const responses_1 = require("./http/responses");
const response_handler_1 = __importDefault(require("./http/response-handler"));
const server_1 = require("./server");
Object.defineProperty(exports, "createServer", { enumerable: true, get: function () { return server_1.createServer; } });
Object.defineProperty(exports, "listRoutes", { enumerable: true, get: function () { return server_1.listRoutes; } });
Object.defineProperty(exports, "listen", { enumerable: true, get: function () { return server_1.listen; } });
Object.defineProperty(exports, "load", { enumerable: true, get: function () { return server_1.load; } });
Object.defineProperty(exports, "printRoutes", { enumerable: true, get: function () { return server_1.printRoutes; } });
const ok = (data) => new responses_1.HttpResponseOK(data);
exports.ok = ok;
const unauthorized = (error) => new responses_1.HttpResponseUnauthorized({
    error,
});
exports.unauthorized = unauthorized;
const err = (error) => new responses_1.HttpResponseBadRequest({
    error,
});
exports.err = err;
const notfound = (error) => new responses_1.HttpResponseNotFound({
    error,
});
exports.notfound = notfound;
// safe async wrap middleware decorators
const Middleware = (mware) => (0, hypernight_1.Middleware)(lodash_1.default.castArray(mware).map((m) => (0, async_express_mw_1.default)(m)));
exports.Middleware = Middleware;
const ClassMiddleware = (mware) => (0, hypernight_1.ClassMiddleware)(lodash_1.default.castArray(mware).map((m) => (0, async_express_mw_1.default)(m)));
exports.ClassMiddleware = ClassMiddleware;
const ErrorMiddleware = (mware) => (0, hypernight_1.ErrorMiddleware)(lodash_1.default.castArray(mware).map((m) => (0, async_express_mw_1.default)(m)));
exports.ErrorMiddleware = ErrorMiddleware;
const ClassErrorMiddleware = (mware) => (0, hypernight_1.ClassErrorMiddleware)(lodash_1.default.castArray(mware).map((m) => (0, async_express_mw_1.default)(m)));
exports.ClassErrorMiddleware = ClassErrorMiddleware;
// </end safe async decorators>
// decorator
const Controller = (path) => (target) => {
    const k = (0, hypernight_1.Controller)(path)(target);
    (0, hypernight_1.ClassWrapper)(response_handler_1.default)(target);
    return k;
};
exports.Controller = Controller;
// api decorators
var hypernight_2 = require("@hyperstackjs/hypernight");
Object.defineProperty(exports, "Delete", { enumerable: true, get: function () { return hypernight_2.Delete; } });
Object.defineProperty(exports, "Get", { enumerable: true, get: function () { return hypernight_2.Get; } });
Object.defineProperty(exports, "Patch", { enumerable: true, get: function () { return hypernight_2.Patch; } });
Object.defineProperty(exports, "Post", { enumerable: true, get: function () { return hypernight_2.Post; } });
Object.defineProperty(exports, "Put", { enumerable: true, get: function () { return hypernight_2.Put; } });
