"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const responses_1 = require("./responses");
const response_sender_1 = __importDefault(require("./response-sender"));
const responseHandler = (fn) => function asyncUtilWrap(request, response, next) {
    const fnReturn = fn(request, response, next);
    Promise.resolve(fnReturn)
        .then((result) => {
        if (result instanceof responses_1.HttpResponse) {
            (0, response_sender_1.default)(response, result);
        }
        else {
            (0, response_sender_1.default)(response, new responses_1.HttpResponseOK(result));
        }
    })
        .catch(next);
};
exports.default = responseHandler;
