"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const glob_1 = require("glob");
const load = (patt, cwd = process.cwd()) => (0, glob_1.globSync)(path_1.default.join(cwd, patt)).map((f) => {
    let mod = null;
    try {
        mod = require(f);
    }
    catch (e) {
        console.log(`error dynamically loading '${f}'\n${e.toString()}`); // eslint-disable-line no-console
        throw e;
    }
    return mod.default || mod;
});
exports.default = load;
