"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const colorette_1 = require("colorette");
const list_routes_1 = __importDefault(require("./list-routes"));
const spacer = (verb, space = 8) => {
    const delta = space - verb.length;
    return verb + ' '.repeat(delta);
};
const verbcolor = (verb) => {
    if (verb.startsWith('GET')) {
        return (0, colorette_1.green)(verb);
    }
    else if (verb.startsWith('DELETE')) {
        return (0, colorette_1.red)(verb);
    }
    else {
        return (0, colorette_1.yellow)(verb);
    }
};
// eslint-disable-next-line no-console
const printRoutes = (app, log = console.log) => {
    const routes = (0, list_routes_1.default)(app);
    for (const route of routes) {
        log(`${verbcolor(spacer(route.verb))} ${route.path}`);
    }
};
exports.default = printRoutes;
