"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const uuid_1 = require("uuid");
const resolveId = (req, opts) => {
    switch (opts.mode) {
        case 'generate': {
            return (0, uuid_1.v4)();
        }
        case 'passthrough': {
            return req.id || req.get('x-request-id');
        }
        case 'passthrough-or-generate': {
            return req.id || req.get('x-request-id') || (0, uuid_1.v4)();
        }
        case 'none': {
            return null;
        }
    }
};
const setRequestId = (opts) => (req, res, next) => {
    req.id = resolveId(req, opts);
    if (req.id) {
        res.set('x-request-id', req.id);
    }
    next();
};
exports.default = setRequestId;
